<?php

    session_start();
    $admin_root = "..";
    $site_root = "../..";
    $path = [ "../../pages" ];

    // ====== Load Functions Libraries ======

    require "$admin_root/repository/functions.php";
    require "$admin_root/repository/cms.php";
    require "$admin_root/repository/xml.php";
    $login = "$admin_root/login.php";
    require "$admin_root/modules/_security.php";

?>

<!doctype html>
<html lang='<?php echo $_SESSION["admin_lang"]; ?>'>
	<head>
		<meta charset="UTF-8">
		<title>X.able CMS / Sitemap generator</title>
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="<?php echo "$admin_root/_tools/_tools.css" ?>" />
        <style></style>
    </head>
    <body>
        <button class='close' onclick="self.close()">X</button>
        
<?php
    
// ===================================================
//                      Sitemap
// ===================================================

    // ====== Generate Sitemap / begin ======
    function sitemapGenerator($json_path, $pages_root, $tags, $navigation) {
    // -------------------------------------------
    // $json_path = <string> JSON file path (relative to root)
    // $root = <string> PHP root
    // $navigation = <array> Navigation XML array
    // -------------------------------------------
    // RETURNS: <array> Full site map tree divided into "inside" and "outside" groups
    // -------------------------------------------
        if($pages_root != "" && substr($pages_root, (strlen($pages_root) - 1)) != "/") { $pages_root = $pages_root."/"; }
        $sitemap = makeSitemap($pages_root, "", $tags, $navigation);
        return $sitemap;
    };
    // ====== Generate Sitemap / end ======
        
    echo "<h1>Sitemap generator</h1><hr>\n";
    if(isset($_POST["action"]) && $_POST["action"] == "sitemap") {
        
        echo "SITEMAP<hr>\n";
        $navigation = loadXml("../../navigation.json");
        $sitemap = sitemapGenerator("test.json", "../../pages", false, $navigation);
        arrayList($sitemap);
        //echo "<hr>INDEX<hr>\n";
        //$index = sitemapIndex($sitemap["inside"]);
        //arrayList($index);
    }
    else {
        echo "<form method='post'>\n";
        echo "<p>Read all documents in navigation tree.</p>\n";
        echo "<button name='action' value='sitemap' type='submit'>Submit</button>\n";
        echo "</form>\n";
    };

?> 
        
    </body>
</html>