function mediaListPage() {
    if(EDIT_PATH == SITE_ROOT + "/@media") {
        setTimeout(function() {
            launchMediaList()
        }, ANIMATION_TIME * 2)
    }
};

function getTreeTitle($label) {
    var title = navItemTitle($label);
    if(title) {
        var $dd = $label.closest("dd");
        if($dd.closest("dl").parent("dd").length) {
            var $sub_label = $dd.closest("dl").parent("dd").children(".nav_item").children(".item_label");
            var sub_title = getTreeTitle($sub_label);
            if(sub_title) { title = sub_title + "/" + title; };
        }
        else if($dd.closest("dl").find("dt")) {
            var $sub_label = $dd.closest("dl").find("dt").children(".nav_item").children(".item_label");
            var sub_title = navItemTitle($sub_label);
            if(sub_title) { title = sub_title + "/" + title; };
        }
        return title;
    }
    else {
        return false;
    }
};

function navItemTitle($label) {
    var href = $label.attr("href");
    if(typeof(href) == "string") {
        if($label.find("span." + ADMIN_LANG).length) {
            var title = $label.find("span." + ADMIN_LANG).text();
        }
        else {
            var title = $label.find("p").text();
            if($label.find("p").children().length) {
                var suffix = $label.find("p").children().text();
                if(typeof(suffix) == "string") {
                    title = title.substr(0, title.length - suffix.length)
                }
            }
        };
        if(typeof(title) != "string" || title == "") {
            title = href.path("filename");
        };
        return title;
    }
    else {
        return false;
    };
}

function launchMediaList() {
    // Disable edit items
    $(".ui-sortable").sortable("destroy");
    $("article > section.media > .media > div .thumb").css("cursor", "default");
    $("article > section.media > .media > div .upload").remove();
    $("article > section.media > .media > div .thumb button.delete").remove();
    $("head").append("<style type=\"text/css\"> #zoom .text_box textarea { display: none; } </style>");
    $("header .buttons button").remove();
    // Gather pages titles form navigation
    var page_title = {};
    $("nav dd > .nav_item .item_label").each(function() {
        var href = $(this).attr("href");
        var title = getTreeTitle($(this));
        if(title != "") { page_title[href] = title; };
    });
    // Add page info & link to every media
    $("article > section.connections").each(function() {
        var connections = {};
        var code = $(this).find("textarea.code").html().split("\n");
        for(i in code) {
            var item = code[i].split(":");
            var href = item.pop();
            var media = item.join(":");
            connections[ media ] = href;
        };
        $(this).closest("article").find("section.media > .media > div .thumb").each(function() {
            if($(this).parent().attr("class").indexOf("video") > -1) {
                var media = $(this).parent().attr("value");
                if(typeof(media) != "string" || media == "") {
                    media = "";
                    $(this).hide(); // hide video update
                }
            }
            else {
                var media = $(this).attr("path");
            };
            if(media != "" && Object.keys(connections).indexOf(media) > -1) {
                var href = connections[media];
                var title = page_title[href];
                if(typeof(title) == "string") {
                    if(title.indexOf("/") > -1) {
                        var dir = title.split("/");
                        title = dir.pop();
                        title = "<span class=\"light_info\">" + dir.join(" / ") + " / </span>" + title;
                    }
                    html = "<button class='link_to_page manual' data-href='" + href + "' help='" + title + "'><span class='fi-anchor'></span></button>";
                    $(this).append(html);
                }
                else if($("footer .advanced_explorer").length) {
                    title = "<span class=\"color_draft\">" + href.path("filename") + "</span>";
                    html = "<button class='link_to_page nav_out manual' data-href='" + href + "' help='" + title + "'><span class='fi-anchor'></span></button>";
                    $(this).append(html);
                }
                else {
                    $(this).hide();
                }
            };
        })
    });
    $("article > section.connections").remove();
    initializeHelp();
    
    // Link to page
    $("article section.media .thumb button.link_to_page").click(function() {
        $(this).blur();
        var href = $(this).attr("data-href");
        href = "index.php?path=" + encodeURI(href) + "&lang=" + LANG;
        //alert(href);
        $("#loader").fadeIn(500, function() {
            location.href = href;
        });
        return false;
    })
    
    // Disable detect changes
    var xml = makeXml();
    $("#detectChanges").val(xml);
    
}